#ifndef __EASYWIZ_H__
#define __EASYWIZ_H__

#ifdef GP2X
	/* Only use GP2X code here */
enum MAP_KEY
{
	VK_UP         , // 0
	VK_UP_LEFT    , // 1
	VK_LEFT       , // 2
	VK_DOWN_LEFT  , // 3
	VK_DOWN       , // 4
	VK_DOWN_RIGHT , // 5
	VK_RIGHT      , // 6
	VK_UP_RIGHT   , // 7
	VK_START      , // 8
	VK_SELECT     , // 9
	VK_FL         , // 10
	VK_FR         , // 11
	VK_FA         , // 12
	VK_FB         , // 13
	VK_FX         , // 14
	VK_FY         , // 15
	VK_VOL_UP     , // 16
	VK_VOL_DOWN   , // 17
	VK_TAT          // 18
};
#endif

#ifdef WIN32
	/* Only use Windows code here */
enum MAP_KEY
{
	VK_UP   = SDLK_UP      , // 0
	VK_UP_LEFT   = SDLK_UP    , // 1
	VK_LEFT   = SDLK_LEFT       , // 2
	VK_DOWN_LEFT   = SDLK_DOWN  , // 3
	VK_DOWN   = SDLK_DOWN       , // 4
	VK_DOWN_RIGHT   = SDLK_DOWN , // 5
	VK_RIGHT   = SDLK_RIGHT      , // 6
	VK_UP_RIGHT   = SDLK_RIGHT   , // 7
	VK_START = SDLK_RETURN      , // 8
	VK_SELECT   = SDLK_SPACE    , // 9
	VK_FL    = SDLK_l        , // 10
	VK_FR    = SDLK_r        , // 11
	VK_FA    = SDLK_s        , // 12
	VK_FB    = SDLK_c        , // 13
	VK_FX    = SDLK_x        , // 14
	VK_FY     = SDLK_d       , // 15
	VK_VOL_UP    = SDLK_UP    , // 16
	VK_VOL_DOWN   = SDLK_UP   , // 17
	VK_TAT        = SDLK_UP     // 18
};
#endif

#ifdef GP2X
#define FRAME_MS 8
#endif

#ifdef WIN32
#define FRAME_MS 16
#endif


extern SDL_Surface *tmp_screen;

#define MAX_IMAGES 1024

typedef struct {
	SDL_Surface *img;
	int x,y;
	int v;
	int frame;
	unsigned short time;
	int anim_fps;
} wz_image;

extern wz_image image[MAX_IMAGES];

typedef struct {
	unsigned char held, released, newpress;
	int x, y;
} wzMouse;

typedef struct {
	unsigned char left, right, up,up_left,up_right, down,down_left,down_right, a,b,x,y,volup,voldown,start,select;
} wzKeys;

typedef struct {
	wzKeys held, released, newpress;
} wzKeyboard;

extern wzKeyboard pad;
extern wzMouse mouse;

extern int input_v;

void wzInit();
int	 wzUpdateInput();
void wzUpdateScreen();
int  wzLoadImage(int n, char *name);
void wzDisplayImage(int n, int x, int y);
void wzDisplayImagePart(int n, int x, int y, int w, int h, int posx, int posy);
int Collision(int ax,int ay,int aw,int ah,int bx,int by,int bw,int bh);

#endif
