#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>

#include "easywiz.h"

int main (int argc, char *argv[])
{    
    wzInit();
    int done=0;
    int GameStatus=0; 
    int AnimCountD=0;
    int AnimCountU=0;
    int AnimCountL=0;
    int AnimCountR=0;
    int ChXPos=100;
    int ChYPos=10;
    int ChX=0;
    int ChY=0;
    int Score=0;
    int StXPos=(rand() % 260);
    int StYPos=(rand() % 160);
    int stick=(rand() % 3)*32;

    int channel;
    int volume=MIX_MAX_VOLUME;
    
	const char* fontFilename = "gfx/Vera.ttf";
    const int fontSize = 12;
	
	Mix_Chunk *pick;
    
    Mix_OpenAudio(22050,MIX_DEFAULT_FORMAT,2,4096);
    TTF_Font *font = TTF_OpenFont(fontFilename,fontSize);
    
    wzLoadImage(0,"gfx/backg.png");
    wzLoadImage(1,"gfx/bekah.png");
    wzLoadImage(2,"gfx/sticks.png");
    wzLoadImage(3,"gfx/black.png");
    wzLoadImage(4,"gfx/MainMenuBG.png");
    
	Mix_Music *bgsong;

    time_t t;
    srand((unsigned) time(&t));

    bgsong = Mix_LoadMUS("gfx/bgsong.wav");
    if(bgsong == NULL) {
        fprintf(stderr, "Unable to load WAV file: %s\n", Mix_GetError());
    }
    
	pick = Mix_LoadWAV("gfx/stick.wav");
    if(pick == NULL) {
        fprintf(stderr, "Unable to load WAV file: %s\n", Mix_GetError());
    }

    Mix_PlayMusic(bgsong,-1);
    
    while(!GameStatus) {
        GameStatus=wzUpdateInput();
        wzDisplayImage(4,0,0);
        if(pad.newpress.start) {
    	    GameStatus=1;
         }
        if(pad.newpress.select) {
            GameStatus=1;
            done=1;
        }
         wzUpdateScreen();
    }
    while(!done) {        
        done=wzUpdateInput();
        wzDisplayImage(3,0,0);
        wzDisplayImage(0,0,15);
        DrawScore(font,Score,0,0);
        DrawRank(font,Score,100,0);
      
        //draw the stick
        wzDisplayImagePart(2,StXPos,StYPos,30,32,stick,0);
        //collide verify
        if(Collision(ChXPos,ChYPos,40,56,StXPos,StYPos,25,25)) {
			StXPos=(rand() % 260);
			StYPos=(rand() % 160);
			stick=(rand() % 3)*32;
			channel = Mix_PlayChannel(1,pick,0);
			Score++;
        }       
        if(AnimCountU==3) {
            ChX=0;
            AnimCountU=0;
            }
        if(AnimCountD==3) {
            ChX=0;
            AnimCountD=0;
            }
        if(AnimCountL==3) {
            ChX=0;
            AnimCountL=0;
            }
        if(AnimCountR==3) {
            ChX=0;
            AnimCountR=0;
            }
            
        if(pad.newpress.up) {
            ChY=64;
            }
        else if(pad.newpress.up_right) {
            ChY=64;
            }
        else if(pad.newpress.up_left) {
            ChY=64;
            }
        if(pad.newpress.down) {
            ChY=0;
            }
		else if(pad.newpress.down_right) {
            ChY=0;
            }
        else if(pad.newpress.down_left) {
            ChY=0;
            }            
        if(pad.newpress.left) {
            ChY=128;
            }
        if(pad.newpress.right) {
            ChY=192;
            }
			
        if(pad.held.up && ChYPos>10) {
            ChX+=48;
            ChYPos-=10;
            AnimCountU++;
            }
    /*    else if(pad.held.up_right && ChYPos>10 && ChXPos<272) {
			ChX+=48;
            ChYPos-=10;
            ChXPos+=10;
            AnimCountU++;
        }
		else if(pad.held.up_left && ChYPos>10 && ChXPos>-10) {
            ChX+=48;
            ChYPos+=10;
            ChXPos+=10;
            AnimCountU++;
        }*/
		if(pad.held.down && ChYPos<172) {   
            ChX+=48;
            ChYPos+=10;
            AnimCountD++;
        }
	/*	else if(pad.held.down_right && ChYPos<172 && ChXPos<272) {
            ChX+=48;
            ChXPos+=10;
            ChYPos+=10;
            AnimCountD++;
        }
		else if(pad.held.down_left && ChYPos<172 && ChXPos>-10) {
            ChX+=48;
            ChXPos-=10;
            ChYPos+=10;
            AnimCountD++;
        }*/
		if(pad.held.left && ChXPos>-10) {       
            ChX+=48;
            ChXPos-=10;
            AnimCountL++;
        }
		else if(pad.held.right && ChXPos<272) {
            ChX+=48;
            ChXPos+=10;
            AnimCountR++;
        } 
        //draw the char
        wzDisplayImagePart(1,ChXPos,ChYPos,48,64,ChX,ChY);
		if(pad.newpress.voldown){
            Mix_VolumeMusic(volume-=30);
            Mix_VolumeChunk(pick, volume-=30);
        }
		if(pad.newpress.volup) {
            Mix_VolumeMusic(volume+=30);
            Mix_VolumeChunk(pick, volume+=30);
        }
        if(pad.newpress.select) done=1;
        SDL_Delay(40);
        wzUpdateScreen();
    }
    Mix_CloseAudio();
    Mix_FreeMusic(bgsong);
    Terminate();    
    return 0;
}



