#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>

#include "easywiz.h"


void DrawText( SDL_Surface* screen, TTF_Font* font, char *text, int x, int y) {
  SDL_Color color = { 255, 255, 255 };
  SDL_Rect coordinates;
  coordinates.x = (int)x;
  coordinates.y = (int)y;
  SDL_Surface *message = NULL;
  message=TTF_RenderText_Solid(font,text,color);
  SDL_BlitSurface(message,0,screen,&coordinates);
  SDL_FreeSurface(message);
}

void DrawScore(TTF_Font *font, int score, int x, int y ) {
    char buffer[500];
    snprintf( buffer, sizeof( buffer ), "Score: %d", score );
    DrawText(tmp_screen,font, buffer, x, y );
}

void DrawRank(TTF_Font *font, int score, int x, int y ) {
    char rankbuffer[500];
    char rank[100];
    if ( score < 10 )	strcpy(rank,"Caveman");
	else if ( score < 20 ) strcpy(rank,"Toothpick Manufacturer");
	else if ( score < 30 ) strcpy(rank, "Whittler");
	else if ( score < 40 ) strcpy(rank, "Wooden Tooth Orthodontist");
	else if ( score < 50 ) strcpy(rank,"Classy wooden animal sculpter");
	else if ( score < 75 ) strcpy(rank, "Canoe Engineer"); 
	else if ( score < 100 )	strcpy(rank, "Trojan");
	else if ( score < 150 )	strcpy(rank, "Yggdrasil"); 
	else if ( score < 200 )	strcpy(rank, "Stick God"); 
	else if ( score < 300 ) strcpy(rank, "IT'S OVER NINE THOUSAAND!!!"); 
    snprintf( rankbuffer, sizeof( rankbuffer ), "Rank: %s",rank);
    DrawText(tmp_screen,font, rankbuffer, x, y );
}
